#include "Chebyshev_Spectral.hpp"

int IsCorner(int tri, int ndx, Overlap overlap, int N)
{
  int count=0;
  IVector k(2);
  IArray W;
  W=Weyl('A',2);
  k(0)=ndx%N;
  k(1)=ndx/N;
  for( unsigned int w=0; w<W.size(); ++w ) { // only one of the possible values of ndx are stored
	ndx=(W(w)(0,0)*k(0)+W(w)(1,0)*k(1))*N+W(w)(0,1)*k(0)+W(w)(1,1)*k(1);
	for( unsigned int c=0; c<overlap.corners.size(); ++c ) // number of corners
	  for( unsigned int t=0; t<overlap.corners(c).size(); ++t ) // number of triangles contributing to corner
		if( tri==overlap.corners(c)(t)(0) ) // found a matching triangle, now check the points
		  for( unsigned int p=1; p<overlap.corners(c)(t).size(); ++p ) // number of points in triangle t contributing to corner c
			if( ndx==overlap.corners(c)(t)(p) ) { // found a match!
			  // count the number of points contributing to this corner
			  for( unsigned int T=0; T<overlap.corners(c).size(); ++T )
				count+=overlap.corners(c)(T).size()-1; // size of the contribution from triangle T
			  return count; // return the number of points contributing to this corner
			}
  }
  return 0;
}

bool IsEdge(int tri, int ndx, Overlap overlap, int N)
{
  IVector k(2);
  IArray W;
  W=Weyl('A',2);
  k(0)=ndx%N;
  k(1)=ndx/N;
  for( unsigned int w=0; w<W.size(); ++w ) { // only one of the possible values of ndx are stored
	ndx=(W(w)(0,0)*k(0)+W(w)(1,0)*k(1))*N+W(w)(0,1)*k(0)+W(w)(1,1)*k(1);
	for( unsigned int e=0; e<overlap.edges.size(); ++e ) // number of edges
	  for( unsigned int t=0; t<overlap.edges(e).size(); ++t ) // number of triangles contributing to edge
		if( tri==overlap.edges(e)(t)(0) ) // found a matching triangle, now check the point
		  if( ndx==overlap.edges(e)(t)(1) ) // found a match!
			return true;
  }
  return false; // return the number of points contributing to this corner
}
