#include "Chebyshev_Spectral.hpp"
#include <boost/numeric/ublas/matrix_proxy.hpp>

#define imod(x,y) ((x)-(y)*(int)floor((double)(x)/(y)))

DArray VtoA(DVector in, int N, int d)
{
  IMatrix fudo;
  IArray W;
  DArray out;

  fudo=primalfudo(N);
  out.resize(2*d*d);
  for( int t=0; t<2*d*d; ++t )
	out(t).resize(N,N);
  W=Weyl('A',2);
  for( int t=0; t<2*d*d; ++t )
	for( unsigned int j=0; j<fudo.size2(); ++j )
	  for( unsigned int w=0; w<W.size(); ++w ) {
		IVector k(2);
		k=prod(trans(W(w)),column(fudo,j));
		out(t)(imod(k(0),N),imod(k(1),N))=in(t*fudo.size2()+j);
	  }
  return out;
}

DVector AtoV(DArray in, int N, int d)
{
  IMatrix fudo;
  DVector out;

  fudo=primalfudo(N);
  out.resize(2*d*d*fudo.size2());
  for( int t=0; t<2*d*d; ++t )
	for( unsigned int j=0; j<fudo.size2(); ++j )
	  out(t*fudo.size2()+j)=in(t)(fudo(0,j),fudo(1,j));
  return out;
}
