/* setdiff(A,B)
 * Input:
 *   A,B  = sorted IVectors.
 *
 * Output:
 *   The values in A that are not in B (cf. setdiff in MATLAB).
 *
 * Brett Ryland, September 2009
 */

#include "Chebyshev_Spectral.hpp"

IVector setdiff(IVector A, IVector B)
{
  unsigned int i=0,j=0,k=0;
  IVector out;

  if( A.size()==0 || B.size()==0 )
	return A;
  out.resize(A.size());
  while( (i<A.size()) && (j<B.size()) ) {
	if( A(i)==B(j) )
	  ++i;
	else
	  if( A(i)<B(j) )
		out(k++)=A(i++);
	  else
		++j;
  }
  while( i<A.size() )
	out(k++)=A(i++);
  out.resize(k,true);
  return out;
}
