#ifndef __Chebyshev_Spectral
#define __Chebyshev_Spectral
// mex.h must be included before Chebyshev_Spectral.hpp if the array_conv() functions are required

#include "Chebyshev.hpp"

class Overlap_Element
{
  public:
	DMatrix Points;
	IVector Index;
};

class Overlap
{
  public:
	boost::numeric::ublas::matrix<Overlap_Element> inner;
	boost::numeric::ublas::vector<boost::numeric::ublas::vector<IVector> > edges, corners;
};

Overlap Construct_Overlap(DArray C, int N);
Overlap Construct_Overlap2(DArray C, int N);

DMatrix Filter(DMatrix in);

DMatrix Gen_Fixed(DArray C, int N);

DMatrix Gen_Projection(DArray C, int N);
DMatrix Gen_Projection2(DArray C, int N);

int IsCorner(int tri, int ndx, Overlap overlap, int N);

bool IsEdge(int tri, int ndx, Overlap overlap, int N);

DArray Smooth_Overlap(Overlap overlap, DArray C, DArray in);
DArray Smooth_Overlap(Overlap overlap, DArray C, DArray in, int maxIter);

IVector setdiff(IVector A, IVector B);

IVector triangle_interior_points2(DMatrix points, DMatrix C);
IVector triangle_interior_points2(DMatrix points, DMatrix C, IVector flags);
IVector triangle_interior_points2(DMatrix points, DMatrix C, IVector flags, double tol);

DArray VtoA(DVector in, int N, int d);
DVector AtoV(DArray in, int N, int d);

#ifdef mex_h
#include "array_conv_Spectral.hpp"
#endif /* mex_h */

#endif /* __Chebyshev_Spectral */
