#include "Chebyshev_Spectral.hpp"
#include <boost/numeric/ublas/matrix_proxy.hpp>

#define imod(x,y) ((x)-(y)*(int)floor((double)(x)/(y)))

DMatrix Gen_Projection(DArray C, int N)
{
  using namespace boost::numeric::ublas;

  int I,J;
  IMatrix fudo;
  DMatrix P,IntT;
  IArray W;
  DArray d;
  Overlap overlap;

  overlap=Construct_Overlap(C, N);
  d.resize(C.size());
  for( unsigned int c=0; c<C.size(); ++c ) {
	d(c).resize(N,N);
  }
  W=Weyl('A',2);
  fudo=primalfudo(N);
  IntT=IntLookup_triangle(N);
  P.resize(fudo.size2()*C.size(),fudo.size2()*C.size());
  I=0;
  for( unsigned int tri=0; tri<C.size(); ++tri ) {
	for( unsigned int i=0; i<fudo.size2(); ++i ) {
	  IVector k(2);
	  // construct delta functions
	  k(0)=fudo(0,i);
	  k(1)=fudo(1,i);
	  for( unsigned int c=0; c<C.size(); ++c )
		d(c).clear();
	  for( unsigned int w=0; w<W.size(); ++w ) {
		IVector K(2);
		K=prod(trans(W(w)),k);
		K(0)=imod(K(0),N);
		K(1)=imod(K(1),N);
		d(tri)(K(0),K(1))=1.;
	  }
	  d=Smooth_Overlap(overlap, C, d, 0);
	  J=0;
	  for( unsigned int tri2=0; tri2<C.size(); ++tri2 )
		for( unsigned int j=0; j<fudo.size2(); ++j ) {
		  P(J,I)=d(tri2)(fudo(0,j),fudo(1,j));
		  ++J;
		}
	  ++I;
	}
  }
  return P;
}
