% timing and accuracy demonstration for functions on the deltoid
Nmax = 100;
iters = 10; % number of loops to average over
disp('computing errors and timing of CCInt, Surface_Area and Gradient routines averaged over several runs')
[I,T]=demo_deltoid_run(Nmax,iters);
I(isnan(I))=0;
figure(1);clf
[ax,h1,h2]=plotyy([1:Nmax],I(1,:),[1:Nmax],T(1,:),'semilogy','plot');
set(ax(1),'xlim',[0 Nmax],'ylim',[1e-16 1e0],'ytick',[1e-16 1e-14 1e-12 1e-10 1e-8 1e-6 1e-4 1e-2 1e0]);
axes(ax(2)); hold on; syms n; b=(T(1,end)-T(1,1))/(Nmax^2-1); a=T(1,1)-b; h=ezplot(a+b*n^2,[0 Nmax]); set(h,'color','r'); xlabel('N');
[a b]
set(ax(2),'xlim',[0 Nmax],'ylim',[0 8*10^floor(log10(T(1,end)))],'ytick',[0:10^floor(log10(T(1,end))):8*10^floor(log10(T(1,end)))]);
title(sprintf('Spectral convergence of integration of exp(sin(x)sin(y))'));
ylabel(ax(1),'Relative error');ylabel(ax(2),'Timing in seconds');
hold off
figure(2);clf
[ax,h1,h2]=plotyy([1:Nmax],I(2,:),[1:Nmax],T(2,:),'semilogy','plot');
set(ax(1),'xlim',[0 Nmax],'ylim',[1e-16 1e0],'ytick',[1e-16 1e-14 1e-12 1e-10 1e-8 1e-6 1e-4 1e-2 1e0]);
axes(ax(2)); hold on; syms n; b=(T(2,end)-T(2,1))/(Nmax^2-1); a=T(2,1)-b; h=ezplot(a+b*n^2,[0 Nmax]); set(h,'color','r'); xlabel('N');
[a b]
set(ax(2),'xlim',[0 Nmax],'ylim',[0 8*10^floor(log10(T(2,end)))],'ytick',[0:10^floor(log10(T(2,end))):8*10^floor(log10(T(2,end)))]);
title(sprintf('Spectral convergence of surface area of exp(sin(x)sin(y))'));
ylabel(ax(1),'Relative error');ylabel(ax(2),'Timing in seconds');
hold off
figure(3);clf
[ax,h1,h2]=plotyy([1:Nmax],I([3 4],:),[1:Nmax],T(3,:),'semilogy','plot');
axes(ax(1)); hold on; plot(ax(1),[1:Nmax],eps*[1:Nmax].^2,'r');
set(ax(1),'xlim',[0 Nmax],'ylim',[1e-16 1e0],'ytick',[1e-16 1e-14 1e-12 1e-10 1e-8 1e-6 1e-4 1e-2 1e0]);
axes(ax(2)); hold on; syms n; b=(T(3,end)-T(3,1))/(Nmax^2-1); a=T(3,1)-b; h=ezplot(a+b*n^2,[0 Nmax]); set(h,'color','r'); xlabel('N');
set(ax(2),'xlim',[0 Nmax],'ylim',[0 8*10^floor(log10(T(3,end)))],'ytick',[0:10^floor(log10(T(3,end))):8*10^floor(log10(T(3,end)))]);
[a b]
set(h1(2),'color',[0 0 0]);
set(h2,'color',[0 0.5 0]);
set(get(ax(2),'ylabel'),'color',[0 0.5 0]);
set(ax(2),'ycolor',[0 0.5 0]);
title(sprintf('Spectral convergence of |\\nabla_{x}exp(sin(x)sin(y))|_{L_{2}}'));
ylabel(ax(1),'L_2 norm of the absolute error');ylabel(ax(2),'Timing in seconds');
hold off
