function [I,T]=demo_nonlinear_triangle(Nmax,iters)
% demo for using Chebyshev polynomials on a nonlinearly deformed triangle
% (iters is not used, but included for compatibility with MEX version)
m=max(dualfudo(Nmax),[],2)+1;
if exist('IntT')~=1 | m(1) > size(IntT,1) | m(2) > size(IntT,2) % only generate IntT if needed
  IntT = IntLookup_triangle(Nmax);
end
I=[];
T=[];
for N=1:Nmax
  theta = [0:N-1]*2*pi/N;
  x=(cos(theta.'*ones(1,N))+cos(ones(N,1)*theta)+cos(theta.'*ones(1,N)-ones(N,1)*theta))/3;x(abs(x)<1e-13)=0;
  y=(sin(theta.'*ones(1,N))-sin(ones(N,1)*theta)-sin(theta.'*ones(1,N)-ones(N,1)*theta))/3;y(abs(y)<1e-13)=0;
  phi=zeros(N,N,2);
  f=zeros(N);

  % initialise the phi map and f function here.
  R=1;
  phi(:,:,1)=R*x./sqrt(x.^2+y.^2+1); % this is a 2d projection of the coordinates on the sphere
  phi(:,:,2)=R*y./sqrt(x.^2+y.^2+1);
  f=R*ones(N)./sqrt(x.^2+y.^2+1); % surface of a sphere of radius R

  % perform the surface area calculation
  tic;
  J=JacobianMap(phi); % for nonlinear mappings
  F=TriangleMap(f,J);
  I=[I;CCInt(F,N,IntT)];
  T=[T;toc];
end
