function [I,T]=demo_triangle_run(Nmax,iters)
% demo for using Chebyshev polynomials on a triangle
C=[0 0 1;0 1 0];
IntT = IntLookup_triangle(Nmax);
func='exp(sin(x).*sin(y))-1';
gradx=inline('cos(x).*sin(y).*exp(sin(x).*sin(y))','x','y');
grady=inline('sin(x).*cos(y).*exp(sin(x).*sin(y))','x','y');
exact_int=TriCCInt(func,C,Nmax,IntT);
[D,x,y]=TriGrad(func,C,Nmax);
S=sqrt(1+gradx(x,y).^2+grady(x,y).^2);
[exact_surface_area]=TriCCInt(S,C,Nmax,IntT);

I=zeros(4,Nmax);
T=ones(3,Nmax);
% TriCCInt
for j=1:iters
  for N=1:Nmax
	tic;
	I(1,N)=abs(TriCCInt(func,C,N,IntT)-exact_int);
	T(1,N)=min(toc,T(1,N));
  end;
end
% TriSurf
for j=1:iters
  for N=1:Nmax
	tic;
	I(2,N)=abs(TriSurf(func,C,N,IntT)-exact_surface_area);
	T(2,N)=min(toc,T(2,N));
  end;
end
for j=1:iters
  for N=1:Nmax
	tic;
	[D,x,y]=TriGrad(func,C,N);
	T(3,N)=min(toc,T(3,N));
	I(3:4,N)=[norm(D(:,:,1)-gradx(x,y))/norm(gradx(x,y)) norm(D(:,:,2)-grady(x,y))/norm(grady(x,y))];
  end;
end
