#include <iostream>
#include <cfloat>
#include <mex.h> // mex.h must be included before Chebyshev.hpp
#include "../Spectral/Chebyshev_Spectral.hpp"

void mexFunction( int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[] )
{
  using namespace std;
  int N;
  DMatrix P;
  DArray C;

  if (nrhs != 2) {
	mexErrMsgTxt("Two input arguments required (C,N).");
  } else if (nlhs > 1) {
	mexErrMsgTxt("Too many output arguments.");
  }

  array_conv(&prhs[0],C);
  N=(int)(*mxGetPr(prhs[1]));
  P=Gen_Projection(C,N);
  array_conv(P,&plhs[0]);
}
