function [J]=JacobianMap(phi)
% Construct the Jacobian of a mapping phi from the equilateral triangle to a nonlinear triangle.
%
% Input:
%	phi (N,N,2) = mapped coordinates of x, i.e., y=phi(x)
%
% Output:
%	J (2,2,N,N) = Jacobian at every point in the domain

N=size(phi,1);
gradphi1=real(Gradient(phi(:,:,1),N));
gradphi2=real(Gradient(phi(:,:,2),N));
J=zeros(2,2,N,N);
for j1=1:N
  for j2=1:N
	J(:,:,j1,j2)=[gradphi1(j1,j2,1) gradphi1(j1,j2,2);gradphi2(j1,j2,1) gradphi2(j1,j2,2)];
  end
end
