function [Gamma] = MakeSym(gen)
% we assume all generators different
d = size(gen,1);
ngen = size(gen,3);
Gamma = cat(3,eye(d),gen);
oldlength = 0; 
newlength = 1+ngen;
while oldlength < newlength,
	% multiply all in list with generators
	for j = 2:newlength,
		new = gen;
		for k = 1:ngen,
			new(:,:,k) = Gamma(:,:,j)*new(:,:,k);
		end;
		% delete repeated entries
		for k = ngen:-1:1,
			for l = 1:size(Gamma,3),
				if norm(Gamma(:,:,l)-new(:,:,k)) < 1e-7,
					new(:,:,k)=[];
					break;
				end;
			end;
    	end;
		Gamma = cat(3,Gamma,new);
	end;
    oldlength = newlength;
	newlength = size(Gamma,3);
	% if newlength>190, break; end; % many of the Weyl groups of dimension >4 have more than 190 elements
end;
% if newlength>190, display('Infinite group?'); end;

