function [T] = T_A2(z,N)
% T_A2 : evaluate chebyshev pol., case A2
%
% Input:
%	z (Nz,1) = complex vector x+iy of evaluation points
%	N = downscaling of root lattice. Indicates how many polynomials should be evaluated.
%
% Output:
%	T (Nz,Nfudo) evaluation for all T_k where k\in dualfudo
%
%    T(:,j) contains evaluation of T_k, where k = fudo(:,j)

fudo = dualfudo(N);
Nfudo = size(fudo,2);
Nz = size(z,1);
zc = conj(z);
T = zeros(Nz,Nfudo);
T(:,1) = 1;
if(N>=2)
  T(:,2) = z;
end
if(N>=4)
  T(:,3) = 3*z.*z - 2*zc;
end
if N==3
  j=3;
else
  j=4;
end
while( j<=Nfudo )
  if( fudo(2,j)==0 )
	T(:,j) = 3*z.*T(:,j-1)-3*zc.*T(:,j-2)+T(:,j-3);
  else
	T(:,j) = (3*T(:,fudo(1,j)+1).*conj(T(:,fudo(2,j)+1))-T(:,fudo(1,j)-fudo(2,j)+1))/2;
  end
  j=j+1;
end
