function [fudo] = restricted_dualfudo(N)
% fundamental domain in Fourier space
% N : downscaling of root lattice.
% restricted version, which excludes some points corresponding to higher order polynomials

% define fundamental domain
fudo = [];
for k2 = 0:N/2
	for k1 = 0:N/2
		if (k1+k2 <= N/2) && (k2 <= k1)
			fudo = [fudo, [k1; k2]];
		end
	end
end
